/**********************************************************
*	File:replace.c
*	This file includes a function that is used to replace the 
*	values in RF buffer.
*
*	return rc 	=0: replace successful
*						 !=0:	fail	
							
*
**********************************************************/

#include "replace.h"


extern int MAC_FLAG;


int replace(unsigned long addr, uchar *value)
{
	int idx = 0, len;
	uchar RFbuf[0x10000];
	int rc=0;
	memset(RFbuf,0,0x10000);
	len = strlen(value);
	if (MAC_FLAG)
	{
		printf("mac flag\n");	// tmp test
		len=6;
	}
	if (0==len)
		{
			printf("\nThe value to replace is vacant!");
			return -1;
		}

	for (idx =0 ;idx <0x10000;idx ++)
		RFbuf[idx]=(*(uint8_t *) (0xbc440000 + idx));

	for (idx =0 ;idx <len; idx++)
		RFbuf[0x00000 + addr + idx] = value[idx];
	
	flash_sect_protect(0, 0xbc440000, 0xbc44ffff);
	
	printf("\n Erase File System block !!\n From 0xBC440000 To 0xBC44FFFF\n");
	flash_sect_erase(0xBC440000, 0xBC44ffff);
	rc = flash_write((uchar *)RFbuf, (ulong)0xbc440000, 0x10000);

	flash_sect_protect(1, 0xbc440000, 0xbc44ffff);
	
	printf("\nrc=%d\n",rc);
	MAC_FLAG=0;
 	return rc;	

}

int chkVer()
{
        int idx, len;
        uchar rfbuf[0x02];
        int ret = 0;

        memset(rfbuf, 0, 0x02);
        for(idx = 0; idx < 2; ++idx)
                rfbuf[idx] = (*(uint8_t *) (0xbc44009c + idx));

        printf("\n## pre-dump ver here:\n");
        for(idx = 0; idx < 2; ++idx)
                printf("[%2x] ", rfbuf[idx]);
        printf("\n");

        if((rfbuf[0] == 0x42) && (rfbuf[1] == 0x32))
        {
                return 1;
        }
	else
	{
		printf("# rewrite version id # as B2\n");
		return 0;
	}
}        

int chkMAC()
{
	int idx, len;
	uchar rfbuf[0x06];
	int ret = 0;

	memset(rfbuf, 0, 0x06);
	for(idx = 0; idx < 0x06; ++idx)
		rfbuf[idx] = (*(uint8_t *) (0xbc440004 + idx));

	printf("\n## pre-dump mac here:\n");
	for(idx = 0; idx < 0x06; ++idx)
		printf("[%2x] ", rfbuf[idx]);
	printf("\n");

	if((rfbuf[0] == 0xff) && (rfbuf[1] == 0xff) && (rfbuf[2] == 0xff) && (rfbuf[3] == 0xff) && (rfbuf[4] == 0xff) && (rfbuf[5] == 0xff))
	{
		printf("\ninvalid mac ff:ff:ff:ff:ff:ff\n");
		return -2;
	}

	if(rfbuf[0] & 0x01)
	{
		printf("\nerr mac with head 01\n");
		return -1;
	}
}

